/* proxy.h -- Proxy support helpers
 * 
 * Copyright (C) 2004 H Zero Seven
 *
 * Authors: Christian Volmering <risk@h07.org>
 * 
 * This file is part of the aexpl-ng distribution.
 * 
 * The aexpl-ng distribution is free software; you can redistribute it 
 * and/or modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2 of 
 * the License, or (at your option) any later version.
 *
 * The aexpl-ng distribution is distributed in the hope that it will
 * be useful, but WITHOUT ANY WARRANTY; without even the implied 
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the aexpl-ng distribution; if not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 * MA 02111-1307 USA
 */

#ifndef _H07_PROXY_H
#define _H07_PROXY_H

#include <curl/curl.h>
#include <string.h>

struct _proxy_config_t
{
  // Whether to use proxy support or not
  short enabled;
  // Proxy type
  char type[7];
  // Hostname and port
  char host[256];
  // Username and password
  char login[128];
};

typedef struct _proxy_config_t proxy_config_t;

#define P_ENABLED(config) (config.enabled)
#define P_HOST(config) (config.host)
#define P_LOGIN(config) (config.login)

#define P_TYPE(config) ( \
  !strcmp (config.type, "http") ? CURLPROXY_HTTP : \
  !strcmp (config.type, "socks4") ? CURLPROXY_SOCKS4 : \
  !strcmp (config.type, "socks5") ? CURLPROXY_SOCKS5 : \
  -1 )

#endif /* _H07_PROXY_H */
