/* version.h -- Version management
 * 
 * Copyright (C) 2004 H Zero Seven
 *
 * Authors: Christian Volmering <risk@h07.org>
 * 
 * This file is part of the aexpl-ng distribution.
 * 
 * The aexpl-ng distribution is free software; you can redistribute it 
 * and/or modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2 of 
 * the License, or (at your option) any later version.
 *
 * The aexpl-ng distribution is distributed in the hope that it will
 * be useful, but WITHOUT ANY WARRANTY; without even the implied 
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
 * See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the aexpl-ng distribution; if not, write to the 
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 * MA 02111-1307 USA
 */

#ifndef _H07_VERSION_H
#define _H07_VERSION_H

// version = major "." minor [ state release ] [ "-" suffix ]
struct _ae_version_t
{
  // major = 1*2(DIGIT) ; Major version
  unsigned short major;
  // minor = 1*2(DIGIT) ; Minor version
  unsigned short minor;
  // state = "a" / "b" ; Alpha or beta state
  char state;
  // release = DIGIT ; Number of releases in this state
  unsigned short release;
  // suffix  = 1*32(ALPHA) ; Use this for special builds
  char suffix[32];
};

typedef struct _ae_version_t ae_version_t;

#define VERSION_INIT {0, 0, 0, 0, "\0"}

#define VERSION_CMP(v1, v2) ( \
  v1.major > v2.major ? 1 : \
  v1.minor > v2.minor ? 1 : \
  v1.state > v2.state ? 1 : \
  (v1.state == 0) && (v2.state != 0) ? 1 : \
  v1.release > v2.release ? 1 : 0 )

extern int parse_version_str (const char *, ae_version_t *);
extern void get_version_str (ae_version_t *, char *);

#endif /* _H07_VERSION_H */

/*
 * Local variables:
 * tab-width: 8
 * c-basic-offset: 8
 * End:
 * vim600: noet nonu sw=8 ts=8 fdm=marker
 * vim<600: noet nonu sw=8 ts=8
 */
